﻿##############################
# $Id: htpasswd.p,v 1.19 2004/01/02 12:28:45 egr Exp $
# Класс для работы с .htpasswd
# Идея Pavel Titov (pavel@titov.pp.ru)
# Я маленько усовершенствовал
#
# Использование:
# $oPass[^htpasswd::init[/path/to/.htpasswd]]
#
# Добавление (изменение пароля) пользователя с передачей
# незашифрованного пароля
# ^oPass.setpw[$sUserName;$sPasswd]
#
# Добавление (изменение пароля) пользователя с передачей уже
# зашифрованного  math:crypt пароля
# ^oPass.setpwCrypted[$sUserName;$sPasswd]
#
# Удаление пользователя
# ^oPass.delete[$sUserName]
@CLASS
htpasswd

##############################
# Конструктор
# _tPasswd - таблица пользователь/пароль
# _sFileName - полный путь к файлу .htpasswd (с путём)
@init[sFileName][lHtpass]
$_sFileName[$sFileName]
^try{
	$lHtpass[^file::load[text;$sFileName]]
	$lHtpass[^lHtpass.text.match[\n][g]{^#0A}]
	$_tPasswd[^table::create{login	password^#0A^lHtpass.match[:][g]{	}}]
}{
	^if($exception.type eq file.missing
		|| $exception.type eq parser.runtime
	){
		$exception.handled(1)
		$_tPasswd[^table::create{login	password}]
	}
}

##############################
# Добавление пользователя / изменение пароля
@setpw[sLogin;sPassword][lCrypted]
$lCrypted[^math:crypt[$sPassword;^$apr1^$]]
^setpwCrypted[$sLogin;$lCrypted]

##############################
# Добавление пользователя / изменение пароля
# с передачей не самого пароля а уже его хэша
# Работает просто - если пользователь есть, он сначала удаляется,
# а потом записывается новый, с таким же именем, но другим паролем
# Если пользователя нет, понятно что происходит в этом случае :)
@setpwCrypted[sLogin;sPassword]
^if(^_tPasswd.locate[login;$sLogin]){
	$_tPasswd[^_remove[$_tPasswd;^_tPasswd.line[];1]]
}

^_tPasswd.append{$sLogin	$sPassword}
^_save[]

##############################
# Удаление пользователя
@delete[sLogin]
^if(^_tPasswd.locate[login;$sLogin]){
	$_tPasswd[^_remove[$_tPasswd;^_tPasswd.line[];1]]
}
^_save[]

##############################
# Сохранение .htpasswd
@_save[]
$result[^_tPasswd.menu{${_tPasswd.login}:$_tPasswd.password^#0A}]
^result.save[$_sFileName]
$result[]

##############################
# http://parser.ru/forum/?id=3803
## удаление строк из таблицы
# результат - таблица
# t - имя таблицы
# from - начиная с какой строки удалять (!!! нумерация строк с 1)
# count - сколько строк удалять
# пример: $mytable[^remove[$mytable;1;10]] - удалит первые 10 строк
@_remove[t;from;count]
^if(def $t){
	$result[^t.select((^t.line[]<$from) || (^t.line[]>=$from+$count))]
}